(defsystem master
;  :documentation "Compile and load *all* code for the thesis"
  :name "master thesis"
  :version "1.0"
  :components
  (;(:file "main")
   (:module breve-interface
    :components ((:file "breve-interface"))
    :pathname "breve-interface/")
   (:module carausius-morosus
    :components ((:file "breve-wrapper"
                  :depends-on ("defpackage"))
                 (:file "central-nervous-system"
                  :depends-on ("defpackage" "locomotion-controller"))
                 (:file "defpackage")
                 (:file "leg-controller"
                  :depends-on ("defpackage" "pacemaker"))
                 (:file "locomotion-controller"
                  :depends-on ("defpackage" "leg-controller"))
                 (:file "pacemaker"
                  :depends-on ("defpackage")))
    :depends-on (breve-interface ctrnn)
    :pathname "creatures/carausius-morosus/")
;   (:module pcnn-carausius-morosus
;    :components ((:file "breve-wrapper"
;                  :depends-on ("defpackage"))
;                 (:file "defpackage")
;                 (:file "neural-system"
;                  :depends-on ("defpackage" "locomotion-controller"))
;                 (:file "leg-controller"
;                  :depends-on ("defpackage" "breve-wrapper"))
;                 (:file "locomotion-controller"
;                  :depends-on ("breve-wrapper" "defpackage" "leg-controller")))
;   :depends-on (breve-interface pcnn)
;   :pathname "creatures/pcnn-carausius-morosus/")
   #+Lispworks(:module capi-extensions
    :components ((:file "capi-extensions")
                 (:file "plot-pane" :depends-on ("capi-extensions")))
    :pathname "capi-extensions/")
   (:module ctrnn
    :components ((:file "defpackage")
                 (:file "ctrnn"
                  :depends-on ("defpackage" "neurons" "synapses"
                                            "neuron-and-synapse-methods"))
                 (:file "neuron-and-synapse-methods"
                  :depends-on ("defpackage" "neurons" "synapses"))
                 (:file "neurons"
                  :depends-on ("defpackage"))
                 (:file "pacemaker"
                  :depends-on ("defpackage" "neurons" "synapses"))
                 (:file "synapses"
                  :depends-on ("defpackage")))
    :depends-on (#+Lispworks capi-extensions)
    :pathname "neural-networks/ctrnn/")
;   (:module leg-controller-ea
;    :components ((:file "defpackage")
;                 (:file "ea" :depends-on ("defpackage")))
;    :depends-on (pcnn-carausius-morosus pcnn breve-interface)
;    :pathname "evolutionary-algorithms/leg-controller/")
   (:module leg-controller
    :components ((:file "defpackage")
                 (:file "leg-controller-take-1" :depends-on ("defpackage"))
                 ;(:file "leg-controller-take-2-4" :depends-on ("defpackage"))
		 ;(:file "leg-controller-take-3" :depends-on ("defpackage"))
                 )
    :depends-on (carausius-morosus #+Lispworks capi-extensions ctrnn
    		utilities)
    :pathname "evolutionary-algorithms/leg-controller/")
   (:module navigation
    :components ((:file "defpackage")
                 ;(:file "turning" :depends-on ("defpackage"))
		 (:file "turningGA" :depends-on ("defpackage")))
    :depends-on (carausius-morosus #+Lispworks capi-extensions ctrnn
     leg-controller utilities)
    :pathname "evolutionary-algorithms/navigation/")
   (:module pacemaker-evolution
    :components ((:file "defpackage")
                 (:file "pacemaker-evolution" :depends-on ("defpackage")))
    :depends-on (ctrnn breve-interface #+Lispworks capi-extensions)
    :pathname "evolutionary-algorithms/pacemaker-evolution/")
;   (:module pcnn
;    :components ((:file "neuron-and-synapse-methods"
;                  :depends-on ("pcnn" "neurons" "synapses"))
;                 (:file "neurons" :depends-on ("pcnn"))
;                 (:file "nn-test" :depends-on ("neurons" "synapses"))
;                 (:file "pcnn")
;                 (:file "synapses" :depends-on ("neurons")))
;    :depends-on (capi-extensions)
;    :pathname "neural-networks/pcnn/"))
     (:module utilities
     :components ((:file "utilities"))
     :depends-on (ctrnn)
     :pathname "evolutionary-algorithms/")
   ) 
  :depends-on ())
