;;;; Created on 2006-11-16 17:48:07
;;;; This file consist of one object, representing the 
;;;; carausius Morosus as seen from the Lisp-side
;;;;
;;;; Methods for this object automatically syncs with the breve instance of the insect

(in-package :carausius-morosus)

(defclass carausius-morosus ()
  (
   ;; Thorax - Coxa joints (tc)
   (tcl0-angle :accessor carausius-morosus-tcl0-angle :initform 0.0)
   (tcl0-stance :accessor carausius-morosus-tcl0-stance :initform 0.0)
   (tcl0-swing :accessor carausius-morosus-tcl0-swing :initform 0.0)

   (tcl1-angle :accessor carausius-morosus-tcl1-angle :initform 0.0)
   (tcl1-stance :accessor carausius-morosus-tcl1-stance :initform 0.0)
   (tcl1-swing :accessor carausius-morosus-tcl1-swing :initform 0.0)

   (tcl2-stance :accessor carausius-morosus-tcl2-stance :initform 0.0)  
   (tcl2-angle :accessor carausius-morosus-tcl2-angle :initform 0.0)
   (tcl2-swing :accessor carausius-morosus-tcl2-swing :initform 0.0)

   (tcr0-angle :accessor carausius-morosus-tcr0-angle :initform 0.0)
   (tcr0-stance :accessor carausius-morosus-tcr0-stance :initform 0.0)
   (tcr0-swing :accessor carausius-morosus-tcr0-swing :initform 0.0)

   (tcr1-angle :accessor carausius-morosus-tcr1-angle :initform 0.0)
   (tcr1-stance :accessor carausius-morosus-tcr1-stance :initform 0.0)
   (tcr1-swing :accessor carausius-morosus-tcr1-swing :initform 0.0)

   (tcr2-angle :accessor carausius-morosus-tcr2-angle :initform 0.0)   
   (tcr2-stance :accessor carausius-morosus-tcr2-stance :initform 0.0)
   (tcr2-swing :accessor carausius-morosus-tcr2-swing :initform 0.0)

   ;; Coxa - femur joints (cf)
   (cfl0-up :accessor carausius-morosus-cfl0-up :initform 0.0)
   (cfl0-down :accessor carausius-morosus-cfl0-down :initform 0.0)

   (cfl1-up :accessor carausius-morosus-cfl1-up :initform 0.0)
   (cfl1-down :accessor carausius-morosus-cfl1-down :initform 0.0)

   (cfl2-up :accessor carausius-morosus-cfl2-up :initform 0.0)
   (cfl2-down :accessor carausius-morosus-cfl2-down :initform 0.0)

   (cfr0-up :accessor carausius-morosus-cfr0-up :initform 0.0)
   (cfr0-down :accessor carausius-morosus-cfr0-down :initform 0.0)

   (cfr1-up :accessor carausius-morosus-cfr1-up :initform 0.0)
   (cfr1-down :accessor carausius-morosus-cfr1-down :initform 0.0)

   (cfr2-up :accessor carausius-morosus-cfr2-up :initform 0.0)
   (cfr2-down :accessor carausius-morosus-cfr2-down :initform 0.0)

   ;; Femur - tibia 
   (ftl0-up :accessor carausius-morosus-ftl0-up :initform 0.0)
   (ftl0-down :accessor carausius-morosus-ftl0-down :initform 0.0)

   (ftl1-up :accessor carausius-morosus-ftl1-up :initform 0.0)
   (ftl1-down :accessor carausius-morosus-ftl1-down :initform 0.0)

   (ftl2-up :accessor carausius-morosus-ftl2-up :initform 0.0)
   (ftl2-down :accessor carausius-morosus-ftl2-down :initform 0.0)

   (ftr0-up :accessor carausius-morosus-ftr0-up :initform 0.0)
   (ftr0-down :accessor carausius-morosus-ftr0-down :initform 0.0)

   (ftr1-up :accessor carausius-morosus-ftr1-up :initform 0.0)
   (ftr1-down :accessor carausius-morosus-ftr1-down :initform 0.0)

   (ftr2-up :accessor carausius-morosus-ftr2-up :initform 0.0)
   (ftr2-down :accessor carausius-morosus-ftr2-down :initform 0.0)

   ;; Tibia - tarsus
   (ttl0-angle :accessor carausius-morosus-ttl0-angle :initform 0.0)
   (ttl1-angle :accessor carausius-morosus-ttl1-angle :initform 0.0)
   (ttl2-angle :accessor carausius-morosus-ttl2-angle :initform 0.0)

   (ttr0-angle :accessor carausius-morosus-ttr0-angle :initform 0.0)
   (ttr1-angle :accessor carausius-morosus-ttr1-angle :initform 0.0)
   (ttr2-angle :accessor carausius-morosus-ttr2-angle :initform 0.0)               
   ;; Head - scape
   (hsr-force :accessor carausius-morosus-hsr-force :initform 0.0)
   (hsr-angle :accessor carausius-morosus-hsr-angle :initform 0.0)
   (hsl-force :accessor carausius-morosus-hsl-force :initform 0.0)
   (hsl-angle :accessor carausius-morosus-hsl-angle :initform 0.0)
   ;; Scape - pedicel
   (spr-angle :accessor carausius-morosus-spr-angle :initform 0.0)
   (spr-force :accessor carausius-morosus-spr-force :initform 0.0)
   (spl-angle :accessor carausius-morosus-spl-angle :initform 0.0)
   (spl-force :accessor carausius-morosus-spl-force :initform 0.0)
   ;; Flagellum odour strength 
   (for-distance :accessor carausius-morosus-for-distance :initform 0.0)
   (fol-distance :accessor carausius-morosus-fol-distance :initform 0.0)
   ;; Flagellum touch strength
   (ftr-strength :accessor carausius-morosus-ftr-strength :initform 0.0)
   (ftl-strength :accessor carausius-morosus-ftl-strength :initform 0.0)
   ))
  
(defun string->list (string)
  (multiple-value-bind (lisp-object next)
      (read-from-string string)
    (if (= next (length string))
      (list lisp-object)
      (cons lisp-object (string->list (subseq string next))))))

(defmethod synchronize-with-breve ((cm carausius-morosus))
  ;; Synch everything _to_ the breve object
  (breve-interface:execute-breve-command
   "set-joint-torques"
   ;; Thorax - Coxa
   (- (carausius-morosus-tcr0-stance cm) (carausius-morosus-tcr0-swing cm))
   (- (carausius-morosus-tcr1-stance cm) (carausius-morosus-tcr1-swing cm))
   (- (carausius-morosus-tcr2-stance cm) (carausius-morosus-tcr2-swing cm))
   (- (carausius-morosus-tcl0-stance cm) (carausius-morosus-tcl0-swing cm))
   (- (carausius-morosus-tcl1-stance cm) (carausius-morosus-tcl1-swing cm))
   (- (carausius-morosus-tcl2-stance cm) (carausius-morosus-tcl2-swing cm))
   ;; Coxa - Femur
;   (- (* (carausius-morosus-cfr0-down cm) 1.5) (carausius-morosus-cfr0-up cm)) ;; NOTE: adjust for a balanced insect
   (- (carausius-morosus-cfr0-down cm) (carausius-morosus-cfr0-up cm)) 
   (- (carausius-morosus-cfr1-down cm) (carausius-morosus-cfr1-up cm))
   (- (carausius-morosus-cfr2-down cm) (carausius-morosus-cfr2-up cm))
;   (- (* (carausius-morosus-cfl0-down cm) 1.5) (carausius-morosus-cfl0-up cm)) ;; NOTE: same here
   (- (carausius-morosus-cfl0-down cm) (carausius-morosus-cfl0-up cm)) 
   (- (carausius-morosus-cfl1-down cm) (carausius-morosus-cfl1-up cm))
   (- (carausius-morosus-cfl2-down cm) (carausius-morosus-cfl2-up cm))
   ;; Femur - Tibia
   (- (carausius-morosus-ftr0-down cm) (carausius-morosus-ftr0-up cm))
   (- (carausius-morosus-ftr1-down cm) (carausius-morosus-ftr1-up cm))
   (- (carausius-morosus-ftr2-down cm) (carausius-morosus-ftr2-up cm))
   (- (carausius-morosus-ftl0-down cm) (carausius-morosus-ftl0-up cm))
   (- (carausius-morosus-ftl1-down cm) (carausius-morosus-ftl1-up cm))
   (- (carausius-morosus-ftl2-down cm) (carausius-morosus-ftl2-up cm))
   ;; Tibia - Tarsus
   0 0 0 0 0 0
   ;; Head scape
   (carausius-morosus-hsl-force cm) (carausius-morosus-hsr-force cm)
   ;; Scape pedicel
   (carausius-morosus-spl-force cm) (carausius-morosus-spr-force cm))
  ;; Then synch everything _from_ the breve object
  (let ((raw-angles (breve-interface:execute-breve-command-with-result
                     "get-joint-angles"))
	(raw-sensors (breve-interface:execute-breve-command-with-result
		      "get-sensor-values")))
    ;; Remove the {} from the result
    (setf raw-angles (string-trim '(#\{ #\}) raw-angles))
    (setf raw-sensors (string-trim '(#\{ #\}) raw-sensors))
    ;; Remove the , from the result
    (setf raw-angles (coerce (loop for char across raw-angles
                                   unless (char-equal char #\,)
                                   collect char)
                             'string))
    (setf raw-sensors (coerce (loop for char across raw-sensors
                                   unless (char-equal char #\,)
                                   collect char)
                             'string))
    ;; Parse the data into a list
    (let ((angles (string->list raw-angles))
	  (sensors (string->list raw-sensors)))
      ;; The first 6 are the thorax - coxa joints
      (setf (carausius-morosus-tcr0-angle cm) (* -1 (nth 0 angles)))
      (setf (carausius-morosus-tcr1-angle cm) (* -1 (nth 1 angles)))
      (setf (carausius-morosus-tcr2-angle cm) (* -1 (nth 2 angles)))
      (setf (carausius-morosus-tcl0-angle cm) (nth 3 angles))
      (setf (carausius-morosus-tcl1-angle cm) (nth 4 angles))
      (setf (carausius-morosus-tcl2-angle cm) (nth 5 angles))
      ;; Then comes the coxa - femur joints 6 - 11
      ;; Then comes the femur - tibia 12 - 17
      ;; Then the tibia - tarsus 18 - 23
      ;; Then head scape joints 24 - 25
      (setf (carausius-morosus-hsl-angle cm) (nth 24 angles))
      (setf (carausius-morosus-hsr-angle cm) (nth 25 angles))
      ;; Then scape pedicel joints 26 27
      (setf (carausius-morosus-spl-angle cm) (nth 26 angles))
      (setf (carausius-morosus-spr-angle cm) (nth 27 angles))
	     
;      (setf (carausius-morosus-ttr0-angle cm) (nth 17 angles))
;      (setf (carausius-morosus-ttr1-angle cm) (nth 18 angles))
;      (setf (carausius-morosus-ttr2-angle cm) (nth 19 angles))
;      (setf (carausius-morosus-ttl0-angle cm) (nth 20 angles))
;      (setf (carausius-morosus-ttl1-angle cm) (nth 21 angles))
;      (setf (carausius-morosus-ttl2-angle cm) (nth 22 angles))
      (setf (carausius-morosus-fol-distance cm) (nth 0 sensors))
      (setf (carausius-morosus-for-distance cm) (nth 1 sensors))
      (setf (carausius-morosus-ftl-strength cm) (nth 2 sensors))
      (setf (carausius-morosus-ftr-strength cm) (nth 3 sensors))
      )))

(defun test-case ()
  (let ((cm (make-instance 'carausius-morosus)))
    (setf (carausius-morosus-tcl1-stance cm) -200)
;    (setf (carausius-morosus-ftr-down cm) 2000)
    (synchronize-with-breve cm)))
            