(defpackage #:carausius-morosus
  (:use "COMMON-LISP" "CTRNN" "BREVE-INTERFACE")
  (:export
   #:central-nervous-system
   #:central-nervous-system-breve-object
   #:central-nervous-system-lobe
   #:central-nervous-system-locomotion-controller
   #:leg-controller-backward-angle-sensor
   #:leg-controller-coxa-angle-sensor
   #:leg-controller-femur-tibia-neuron
   #:leg-controller-foot-neuron
   #:leg-controller-forward-angle-sensor
   #:leg-controller-pacemaker
   #:leg-controller-pacemaker-neuron
   #:leg-controller-stance-neuron
   #:leg-controller-swing-neuron
   #:locomotion-controller-l1
   #:locomotion-controller-l2
   #:locomotion-controller-l3
   #:locomotion-controller-lc-neuron
   #:locomotion-controller-r1
   #:locomotion-controller-r2
   #:locomotion-controller-r3
   #:synchronize-with-breve
   ))
   

(in-package :carausius-morosus)

(defparameter *maximum-femur-tibia-force* 20000)
(defparameter *maximum-leg-down-force* 50000)
(defparameter *maximum-leg-force* 30000)

(defparameter *tolerance* 0.05)

(defparameter *AEP-L1* (+ (* 1.0 (/ pi 4)) (* (* 1.0 (/ pi 4)) *tolerance*)))
(defparameter *AEP-L2* (+ (* 1.55 (/ pi 4)) (* (* 1.55 (/ pi 4)) *tolerance*)))
(defparameter *AEP-L3* (+ (* 2.1 (/ pi 4)) (* (* 2.1 (/ pi 4)) *tolerance*)))
(defparameter *AEP-R1* *AEP-L1*)
(defparameter *AEP-R2* *AEP-L2*)
(defparameter *AEP-R3* *AEP-L3*)
(defparameter *PEP-L1* (- (* 1.9 (/ pi 4)) (* (* 1.9 (/ pi 4)) *tolerance*)))
(defparameter *PEP-L2* (- (* 2.45 (/ pi 4)) (* (* 2.45 (/ pi 4)) *tolerance*)))
(defparameter *PEP-L3* (- (* 3.0 (/ pi 4)) (* (* 3.0 (/ pi 4)) *tolerance*)))
(defparameter *PEP-R1* *PEP-L1*)
(defparameter *PEP-R2* *PEP-L2*)
(defparameter *PEP-R3* *PEP-L3*)
  