(in-package :carausius-morosus)

(defclass locomotion-controller (neural-network)
  ((lc-neuron
    :accessor locomotion-controller-lc-neuron
    :documentation "Controls type of gait the legs should be coordinated into."
    :initarg :lc-neuron
    :initform (make-instance 'neuron))
   (l1
    :accessor locomotion-controller-l1
    :documentation "A leg controller for the front left leg."
    :initarg :l1
    :initform (make-instance 'leg-controller))
   (l2
    :accessor locomotion-controller-l2
    :documentation "A leg controller for the middle left leg."
    :initarg :l2
    :initform (make-instance 'leg-controller))
   (l3
    :accessor locomotion-controller-l3
    :documentation "A leg controller for the hind left leg."
    :initarg :l3
    :initform (make-instance 'leg-controller))
   (r1
    :accessor locomotion-controller-r1
    :documentation "A leg controller for the front right leg."
    :initarg :r1
    :initform (make-instance 'leg-controller))
   (r2
    :accessor locomotion-controller-r2
    :documentation "A leg controller for the middle right leg."
    :initarg :r2
    :initform (make-instance 'leg-controller))
   (r3
    :accessor locomotion-controller-r3
    :documentation "A leg controller for the hind right leg."
    :initarg :r3
    :initform (make-instance 'leg-controller))))

(defmethod initialize-instance :after ((locomotion-controller locomotion-controller) &rest args)
  (declare (ignore args))
;  (set-up-connections locomotion-controller -35))
  )

(defmethod set-up-connections ((locomotion-controller locomotion-controller) synaptic-strength)
  "Set up all synaptic connections."
  ;; The pacemaker units are interconnected
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r1 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron
                  (leg-controller-pacemaker
                   (locomotion-controller-l1 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l1 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron
                  (leg-controller-pacemaker
                   (locomotion-controller-r1 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-l2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-r2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r3 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron
                  (leg-controller-pacemaker
                   (locomotion-controller-l3 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l3 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron
                  (leg-controller-pacemaker
                   (locomotion-controller-r3 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-l1 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l1 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron
                  (leg-controller-pacemaker
                   (locomotion-controller-l2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l3 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-l2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-l2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-l3 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-r1 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r1 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-r2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r3 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-r2 locomotion-controller)))
    :strength synaptic-strength))
  (add-synapse!
   (pacemaker-io-neuron
    (leg-controller-pacemaker (locomotion-controller-r2 locomotion-controller)))
   (make-instance
    'synapse
    :from-neuron (pacemaker-io-neuron 
                  (leg-controller-pacemaker
                   (locomotion-controller-r3 locomotion-controller)))
    :strength synaptic-strength))
  ;; Set the lc neuron of all leg controllers to be the
  ;; lc neuron of the locomotion controller
  (dolist
      (leg-controller (list (locomotion-controller-l1 locomotion-controller)
                            (locomotion-controller-l2 locomotion-controller)
                            (locomotion-controller-l3 locomotion-controller)
                            (locomotion-controller-r1 locomotion-controller)
                            (locomotion-controller-r2 locomotion-controller)
                            (locomotion-controller-r3 locomotion-controller)))
    (setf (leg-controller-lc-neuron leg-controller)
          (locomotion-controller-lc-neuron locomotion-controller))))
                    
(defmethod ctrnn::neural-network-neurons ((locomotion-controller locomotion-controller))
  "List all neurons in network."
  (remove-duplicates ; Some neurons may be shared (e.g. lc neuron)
   (append (list (locomotion-controller-lc-neuron locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-l1 locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-l2 locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-l3 locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-r1 locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-r2 locomotion-controller))
           (neural-network-neurons
            (locomotion-controller-r3 locomotion-controller)))))
