(in-package :ctrnn)

(defclass pacemaker (neural-network)
  ((io-neuron
    :accessor pacemaker-io-neuron
    :documentation "A neuron that has connections to the outside word."
    :initarg :io-neuron
    :initform (make-instance 'neuron))
   (hidden-neuron
    :accessor pacemaker-hidden-neuron
    :documentation "A neuron connection to the io-neuron to make pulse behaviour."
    :initarg :hidden-neuron
    :initform (make-instance 'neuron))))


(defmethod initialize-instance :after ((p pacemaker) &rest args)
  "Connect neurons together."
  (declare (ignore args))
  ;done by genotype->phenotype conversion for now, since weights are not
  ;known
  )


(defmethod ctrnn::neural-network-neurons ((pacemaker pacemaker))
  "A method to list all neurons in this neural network."
  (remove-duplicates 
   (list (pacemaker-io-neuron pacemaker)
         (pacemaker-hidden-neuron pacemaker))))
;         (pacemaker-hidden-neuron-2 pacemaker))))
